diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/deprecated.h ns-3.31/src/core/model/deprecated.h
--- ns-3.30.1/src/core/model/deprecated.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/deprecated.h	2020-06-27 17:38:30.000000000 -0700
@@ -39,8 +39,10 @@
  *
  * For example,
  * \snippet src/core/doc/deprecated-example.h doxygen snippet
+ *
+ * To ease future maintenance please use the versioned forms:
+ * `NS_DEPRECATED_3_XX`, not the generic `NS_DEPRECATED`
  */
-
 #if defined(__GNUC__)
 /* Test for GCC >= 4.1 */
 #define GCC_VERSION (__GNUC__ * 10000 + __GNUC_MINOR__ * 100)
@@ -60,4 +62,22 @@
 #define NS_DEPRECATED
 #endif
 
+/**
+ * \ingroup core
+ * \def NS_DEPRECATED_3_31
+ * Tag for things deprecated in version ns-3.31.
+ */
+#ifdef NS_DEPRECATED
+#define NS_DEPRECATED_3_31 NS_DEPRECATED
+#endif
+
+/**
+ * \ingroup core
+ * \def NS_DEPRECATED_3_30
+ * Tag for things deprecated in version ns-3.30.
+ */
+#ifdef NS_DEPRECATED
+#define NS_DEPRECATED_3_30 NS_DEPRECATED
+#endif
+
 #endif /* NS3_DEPRECATED_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/des-metrics.cc ns-3.31/src/core/model/des-metrics.cc
--- ns-3.30.1/src/core/model/des-metrics.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/des-metrics.cc	2020-06-27 17:38:30.000000000 -0700
@@ -38,7 +38,7 @@
 /* static */
 std::string DesMetrics::m_outputDir; // = "";
 
-void 
+void
 DesMetrics::Initialize (std::vector<std::string> args, std::string outDir /* = "" */ )
 {
   if (m_initialized)
@@ -78,9 +78,12 @@
   m_os << " \"command_line_arguments\" : \"";
   if (args.size () == 0)
     {
-      for (std::size_t i = 0; i < args.size (); ++i) 
+      for (std::size_t i = 0; i < args.size (); ++i)
         {
-          if (i > 0) m_os << " ";
+          if (i > 0)
+            {
+              m_os << " ";
+            }
           m_os << args[i];
         }
     }
@@ -92,7 +95,7 @@
   m_os << " \"events\" : [" << std::endl;
 
   m_separator = ' ';
- 
+
 }
 
 void
@@ -100,7 +103,7 @@
 {
   TraceWithContext (Simulator::GetContext (), now, delay);
 }
- 
+
 void
 DesMetrics::TraceWithContext (uint32_t context, const Time & now, const Time & delay)
 {
@@ -120,7 +123,7 @@
   // Force to signed so we can show NoContext as '-1'
   int32_t send = (sendCtx != Simulator::NO_CONTEXT) ? (int32_t)sendCtx : -1;
   int32_t recv = (context != Simulator::NO_CONTEXT) ? (int32_t)context : -1;
-  
+
   ss <<                                 "  [\""
      << send                         << "\",\""
      << now.GetTimeStep ()           << "\",\""
@@ -144,7 +147,7 @@
 DesMetrics::Close (void)
 {
   m_os << std::endl;    // Finish the last event line
-  
+
   m_os << " ]" << std::endl;
   m_os << "}" << std::endl;
   m_os.close ();
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/double.cc ns-3.31/src/core/model/double.cc
--- ns-3.30.1/src/core/model/double.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/double.cc	2020-06-27 17:38:30.000000000 -0700
@@ -55,8 +55,10 @@
     Checker (double minValue, double maxValue, std::string name)
       : m_minValue (minValue),
         m_maxValue (maxValue),
-        m_name (name) {}
-    virtual bool Check (const AttributeValue &value) const {
+        m_name (name)
+    {}
+    virtual bool Check (const AttributeValue &value) const
+    {
       NS_LOG_FUNCTION (&value);
       const DoubleValue *v = dynamic_cast<const DoubleValue *> (&value);
       if (v == 0)
@@ -65,25 +67,30 @@
         }
       return v->Get () >= m_minValue && v->Get () <= m_maxValue;
     }
-    virtual std::string GetValueTypeName (void) const {
+    virtual std::string GetValueTypeName (void) const
+    {
       NS_LOG_FUNCTION_NOARGS ();
       return "ns3::DoubleValue";
     }
-    virtual bool HasUnderlyingTypeInformation (void) const {
+    virtual bool HasUnderlyingTypeInformation (void) const
+    {
       NS_LOG_FUNCTION_NOARGS ();
       return true;
     }
-    virtual std::string GetUnderlyingTypeInformation (void) const {
+    virtual std::string GetUnderlyingTypeInformation (void) const
+    {
       NS_LOG_FUNCTION_NOARGS ();
       std::ostringstream oss;
       oss << m_name << " " << m_minValue << ":" << m_maxValue;
       return oss.str ();
     }
-    virtual Ptr<AttributeValue> Create (void) const {
+    virtual Ptr<AttributeValue> Create (void) const
+    {
       NS_LOG_FUNCTION_NOARGS ();
       return ns3::Create<DoubleValue> ();
     }
-    virtual bool Copy (const AttributeValue &source, AttributeValue &destination) const {
+    virtual bool Copy (const AttributeValue &source, AttributeValue &destination) const
+    {
       NS_LOG_FUNCTION (&source << &destination);
       const DoubleValue *src = dynamic_cast<const DoubleValue *> (&source);
       DoubleValue *dst = dynamic_cast<DoubleValue *> (&destination);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/empty.h ns-3.31/src/core/model/empty.h
--- ns-3.30.1/src/core/model/empty.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/empty.h	2020-06-27 17:38:30.000000000 -0700
@@ -30,7 +30,8 @@
 /**
  * \brief make Callback use a separate empty type
  */
-class empty {};
+class empty
+{};
 }
 
 #endif /* EMPTY_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/enum.cc ns-3.31/src/core/model/enum.cc
--- ns-3.30.1/src/core/model/enum.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/enum.cc	2020-06-27 17:38:30.000000000 -0700
@@ -20,6 +20,7 @@
 #include "enum.h"
 #include "fatal-error.h"
 #include "log.h"
+#include <algorithm>  // find_if
 #include <sstream>
 
 /**
@@ -60,39 +61,23 @@
   NS_LOG_FUNCTION (this);
   return ns3::Create<EnumValue> (*this);
 }
-std::string 
+std::string
 EnumValue::SerializeToString (Ptr<const AttributeChecker> checker) const
 {
   NS_LOG_FUNCTION (this << checker);
   const EnumChecker *p = dynamic_cast<const EnumChecker *> (PeekPointer (checker));
   NS_ASSERT (p != 0);
-  for (EnumChecker::ValueSet::const_iterator i = p->m_valueSet.begin (); i != p->m_valueSet.end (); i++)
-    {
-      if (i->first == m_value)
-        {
-          return i->second;
-        }
-    }
-
-  NS_FATAL_ERROR ("The user has set an invalid C++ value in this Enum");
-  // quiet compiler.
-  return "";
+  std::string name = p->GetName (m_value);
+  return name;
 }
-bool 
+bool
 EnumValue::DeserializeFromString (std::string value, Ptr<const AttributeChecker> checker)
 {
   NS_LOG_FUNCTION (this << value << checker);
   const EnumChecker *p = dynamic_cast<const EnumChecker *> (PeekPointer (checker));
   NS_ASSERT (p != 0);
-  for (EnumChecker::ValueSet::const_iterator i = p->m_valueSet.begin (); i != p->m_valueSet.end (); i++)
-    {
-      if (i->second == value)
-        {
-          m_value = i->first;
-          return true;
-        }
-    }
-  return false;
+  m_value = p->GetValue (value);
+  return true;
 }
 
 EnumChecker::EnumChecker ()
@@ -112,6 +97,24 @@
   NS_LOG_FUNCTION (this << value << name);
   m_valueSet.push_back (std::make_pair (value, name));
 }
+std::string
+EnumChecker::GetName (int value) const
+{
+  auto it = std::find_if (m_valueSet.begin (), m_valueSet.end (),
+                          [value] (Value v) { return v.first == value; } );
+  NS_ASSERT_MSG (it != m_valueSet.end (),
+                 "invalid enum value " << value << "! Missed entry in MakeEnumChecker?");
+  return it->second;
+}
+int
+EnumChecker::GetValue (const std::string name) const
+{
+  auto it = std::find_if (m_valueSet.begin (), m_valueSet.end (),
+                          [name] (Value v) { return v.second == name; } );
+  NS_ASSERT_MSG (it != m_valueSet.end (),
+                 "name " << name << " not a valid enum value. Missed entry in MakeEnumChecker?");
+  return it->first;
+}
 bool
 EnumChecker::Check (const AttributeValue &value) const
 {
@@ -121,40 +124,33 @@
     {
       return false;
     }
-  for (ValueSet::const_iterator i = m_valueSet.begin (); i != m_valueSet.end (); i++)
-    {
-      if (i->first == p->Get ())
-        {
-          return true;
-        }
-    }
-  return false;
+  auto pvalue = p->Get ();
+  auto it = std::find_if (m_valueSet.begin (), m_valueSet.end (),
+                          [pvalue] (Value v) { return v.first == pvalue; } );
+  return (it != m_valueSet.end ()) ? true : false;
 }
-std::string 
+std::string
 EnumChecker::GetValueTypeName (void) const
 {
   NS_LOG_FUNCTION (this);
   return "ns3::EnumValue";
 }
-bool 
+bool
 EnumChecker::HasUnderlyingTypeInformation (void) const
 {
   NS_LOG_FUNCTION (this);
   return true;
 }
-std::string 
+std::string
 EnumChecker::GetUnderlyingTypeInformation (void) const
 {
   NS_LOG_FUNCTION (this);
   std::ostringstream oss;
-  for (ValueSet::const_iterator i = m_valueSet.begin (); i != m_valueSet.end ();)
+  bool moreValues = false;
+  for (const auto &i : m_valueSet)
     {
-      oss << i->second;
-      i++;
-      if (i != m_valueSet.end ())
-        {
-          oss << "|";
-        }
+      oss << (moreValues ? "|" : "") << i.second;
+      moreValues = true;
     }
   return oss.str ();
 }
@@ -165,7 +161,7 @@
   return ns3::Create<EnumValue> ();
 }
 
-bool 
+bool
 EnumChecker::Copy (const AttributeValue &source, AttributeValue &destination) const
 {
   NS_LOG_FUNCTION (this << &source << &destination);
@@ -180,7 +176,7 @@
 }
 
 
-Ptr<const AttributeChecker> 
+Ptr<const AttributeChecker>
 MakeEnumChecker (int v1, std::string n1,
                  int v2, std::string n2,
                  int v3, std::string n3,
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/enum.h ns-3.31/src/core/model/enum.h
--- ns-3.30.1/src/core/model/enum.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/enum.h	2020-06-27 17:38:30.000000000 -0700
@@ -96,10 +96,25 @@
   /**
    * Add a new value.
    * \param [in] value The value.
-   * \param [in] name Then enum symbol name.
+   * \param [in] name The enum symbol name.
    */
   void Add (int value, std::string name);
 
+  /**
+   * Get the enum symbol name by value.
+   * \param [in] value The value.
+   * \return The enum symbol name.
+   */
+  std::string GetName (int value) const;
+
+  /**
+   * Get the enum value by name.
+   * \param [in] name Then enum symbol name.
+   * \returns The enum value.
+   */
+  int GetValue (const std::string name) const;
+  
+  // Inherited
   virtual bool Check (const AttributeValue &value) const;
   virtual std::string GetValueTypeName (void) const;
   virtual bool HasUnderlyingTypeInformation (void) const;
@@ -108,9 +123,10 @@
   virtual bool Copy (const AttributeValue &src, AttributeValue &dst) const;
 
 private:
-  friend class EnumValue;
+  /** Type for the pair value, name */
+  typedef std::pair<int,std::string> Value;
   /** Type of container for storing Enum values and symbol names. */
-  typedef std::list<std::pair<int,std::string> > ValueSet;
+  typedef std::list<Value> ValueSet;
   /** The stored Enum values and symbol names. */
   ValueSet m_valueSet;
 };
@@ -176,7 +192,7 @@
  * \param [in] n21 The corresponding name.
  * \param [in] v22 A enum value
  * \param [in] n22 The corresponding name.
- */ 
+ */
 Ptr<const AttributeChecker> MakeEnumChecker (int v1, std::string n1,
                                              int v2 = 0, std::string n2 = "",
                                              int v3 = 0, std::string n3 = "",
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/event-id.cc ns-3.31/src/core/model/event-id.cc
--- ns-3.30.1/src/core/model/event-id.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/event-id.cc	2020-06-27 17:38:30.000000000 -0700
@@ -55,6 +55,12 @@
   NS_LOG_FUNCTION (this);
   Simulator::Cancel (*this);
 }
+void
+EventId::Remove (void)
+{
+  NS_LOG_FUNCTION (this);
+  Simulator::Remove (*this);
+}
 bool
 EventId::IsExpired (void) const
 {
@@ -73,19 +79,19 @@
   NS_LOG_FUNCTION (this);
   return PeekPointer (m_eventImpl);
 }
-uint64_t 
+uint64_t
 EventId::GetTs (void) const
 {
   NS_LOG_FUNCTION (this);
   return m_ts;
 }
-uint32_t 
+uint32_t
 EventId::GetContext (void) const
 {
   NS_LOG_FUNCTION (this);
   return m_context;
 }
-uint32_t 
+uint32_t
 EventId::GetUid (void) const
 {
   NS_LOG_FUNCTION (this);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/event-id.h ns-3.31/src/core/model/event-id.h
--- ns-3.30.1/src/core/model/event-id.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/event-id.h	2020-06-27 17:38:30.000000000 -0700
@@ -41,16 +41,17 @@
  * Each EventId identifies a unique event scheduled with one
  * of the many Simulator::Schedule() methods. This EventId can
  * be used to cancel or remove events after they are scheduled
- * with Simulator::Cancel() or Simulator::Remove().
+ * with Cancel(), Remove(), or Simulator::Cancel() or Simulator::Remove().
  *
  * The important thing to remember about this class is that
- * every variable of this type is _always_ in a valid state, 
+ * every variable of this type is _always_ in a valid state,
  * even when it has not been assigned an EventId coming from a
  * Simulator::Schedule() method:  calling Simulator::Cancel(), IsRunning(),
  * IsExpired() or passing around instances of this object
  * will not result in crashes or memory leaks.
  */
-class EventId {
+class EventId
+{
 public:
   /** Default constructor. This EventId does nothing. */
   EventId ();
@@ -69,6 +70,11 @@
    */
   void Cancel (void);
   /**
+   * This method is syntactic sugar for the ns3::Simulator::Remove
+   * method.
+   */
+  void Remove (void);
+  /**
    * This method is syntactic sugar for the ns3::Simulator::IsExpired
    * method.
    * \returns \c true if the event has expired, \c false otherwise.
@@ -76,10 +82,11 @@
   bool IsExpired (void) const;
   /**
    * This method is syntactic sugar for !IsExpired().
-   * 
+   *
    * \returns \c true if the event has not expired, \c false otherwise.
    */
   bool IsRunning (void) const;
+
 public:
   /**
    * \name Scheduler Helpers.
@@ -88,7 +95,7 @@
    */
   /**@{*/
   /** \return The underlying EventImpl pointer. */
-  EventImpl *PeekEventImpl (void) const;
+  EventImpl * PeekEventImpl (void) const;
   /** \return The virtual time stamp. */
   uint64_t GetTs (void) const;
   /** \return The event context. */
@@ -96,26 +103,26 @@
   /** \return The unique id. */
   uint32_t GetUid (void) const;
   /**@}*/
-  
+
   /**
    * Test if two EventId's are equal.
    * \param [in] a The first EventId.
    * \param [in] b The second EventId.
-   * \return \c true if the \p a and \p b represent the same event.
+   * \return \c true if the \pname{a} and \pname{b} represent the same event.
    */
   friend bool operator == (const EventId &a, const EventId &b);
   /**
    * Test if two EventId's are not equal.
    * \param [in] a The first EventId.
    * \param [in] b The second EventId.
-   * \return \c true if the \p a and \p b are not the same event.
+   * \return \c true if the \pname{a} and \pname{b} are not the same event.
    */
   friend bool operator != (const EventId &a, const EventId &b);
   /**
    * Less than operator for two EventId's, based on time stamps.
    * \param [in] a The first EventId.
    * \param [in] b The second EventId.
-   * \return \c true if \p a occurs before \p b.
+   * \return \c true if \pname{a} occurs before \pname{b}.
    */
   friend bool operator <  (const EventId &a, const EventId &b);
 
@@ -130,25 +137,25 @@
  **  Inline implementations
  ************************************************/
 
-inline  
+inline
 bool
 operator == (const EventId &a, const EventId &b)
 {
-  return 
-    a.m_uid == b.m_uid && 
-    a.m_context == b.m_context && 
-    a.m_ts == b.m_ts && 
-    a.m_eventImpl == b.m_eventImpl;
+  return
+    a.m_uid == b.m_uid
+    && a.m_context == b.m_context
+    && a.m_ts == b.m_ts
+    && a.m_eventImpl == b.m_eventImpl;
 }
-  
-inline  
+
+inline
 bool
 operator != (const EventId &a, const EventId &b)
 {
   return !(a == b);
 }
-  
-inline  
+
+inline
 bool
 operator <  (const EventId &a, const EventId &b)
 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/example-as-test.cc ns-3.31/src/core/model/example-as-test.cc
--- ns-3.30.1/src/core/model/example-as-test.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/core/model/example-as-test.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,143 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Lawrence Livermore National Laboratory
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Peter D. Barnes, Jr. <pdbarnes@llnl.gov>
+ */
+
+#include "example-as-test.h"
+#include "ascii-test.h"
+#include "log.h"
+#include "unused.h"
+#include "assert.h"
+
+#include <string>
+#include <sstream>
+#include <cstdlib>  // itoa(), system ()
+
+/**
+ * \file
+ * \ingroup testing
+ * Implementation of classes ns3::ExampleAsTestSuite and ns3::ExampleTestCase.
+ */
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("ExampleAsTestCase");
+
+// Running tests as examples currently requires bash shell; uses Unix
+// piping that does not work on Windows.
+#if defined(NS3_ENABLE_EXAMPLES) && !defined (__win32__)
+
+ExampleAsTestCase::ExampleAsTestCase (const std::string name,
+                                      const std::string program,
+                                      const std::string dataDir,
+                                      const std::string args /* = "" */)
+  : TestCase (name),
+    m_program (program),
+    m_dataDir (dataDir),
+    m_args (args)
+{
+  NS_LOG_FUNCTION (this << name << program << dataDir << args);
+}
+
+ExampleAsTestCase::~ExampleAsTestCase (void)
+{
+  NS_LOG_FUNCTION_NOARGS ();
+}
+
+std::string
+ExampleAsTestCase::GetCommandTemplate (void) const
+{
+  NS_LOG_FUNCTION_NOARGS ();
+  std::string command ("%s ");
+  command += m_args;
+  return command;
+}
+
+std::string
+ExampleAsTestCase::GetPostProcessingCommand (void) const
+{
+  NS_LOG_FUNCTION_NOARGS ();
+  std::string command ("");
+  return command;
+}
+
+void
+ExampleAsTestCase::DoRun (void)
+{
+  NS_LOG_FUNCTION_NOARGS ();
+  // Set up the output file names
+  SetDataDir (m_dataDir);
+  std::string refFile = CreateDataDirFilename (GetName () + ".reflog");
+  std::string testFile = CreateTempDirFilename  (GetName () + ".reflog");
+
+  std::stringstream ss;
+
+  // Use bash as shell to allow use of PIPESTATUS
+  ss << "bash -c './waf --run-no-build " << m_program
+     << " --command-template=\"" << GetCommandTemplate () << "\""
+
+    // redirect std::clog, std::cerr to std::cout
+     << " 2>&1 "
+
+    // Suppress the waf lines from output; waf output contains directory paths which will
+    // obviously differ during a test run
+     << " | grep -v 'Waf:' "
+     << GetPostProcessingCommand ()
+     << " > " << testFile
+
+    // Get the status of waf
+     << "; exit ${PIPESTATUS[0]}'";
+
+  int status = std::system (ss.str ().c_str ());
+
+  std::cout << "command:  " << ss.str () << "\n"
+            << "status:   " << status << "\n"
+            << "refFile:  " << refFile   << "\n"
+            << "testFile: " << testFile  << "\n"
+            << std::endl;
+  std::cout << "testFile contents:" << std::endl;
+
+  std::ifstream logF (testFile);
+  std::string line;
+  while (getline (logF, line))
+    {
+      std::cout << line << "\n";
+    }
+  logF.close ();
+
+  // Make sure the example didn't outright crash
+  NS_TEST_ASSERT_MSG_EQ (status, 0, "example " + m_program + " failed");
+
+  // Compare the testFile to the reference file
+  NS_ASCII_TEST_EXPECT_EQ (testFile, refFile);
+}
+
+ExampleAsTestSuite::ExampleAsTestSuite (const std::string name,
+                                        const std::string program,
+                                        const std::string dataDir,
+                                        const std::string args /* = "" */,
+                                        const TestDuration duration /* =QUICK */)
+  : TestSuite (name, EXAMPLE)
+{
+  NS_LOG_FUNCTION (this << name << program << dataDir << args << duration);
+  AddTestCase (new ExampleAsTestCase (name, program, dataDir, args), duration);
+}
+
+#endif // NS3_ENABLE_EXAMPLES && !defined (__win32__)
+
+}  // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/example-as-test.h ns-3.31/src/core/model/example-as-test.h
--- ns-3.30.1/src/core/model/example-as-test.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/core/model/example-as-test.h	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,214 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Lawrence Livermore National Laboratory
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Peter D. Barnes, Jr. <pdbarnes@llnl.gov>
+ */
+
+#ifndef NS3_EXAMPLE_AS_TEST_SUITE_H
+#define NS3_EXAMPLE_AS_TEST_SUITE_H
+
+#include "ns3/test.h"
+
+#include <string>
+
+/**
+ * \file
+ * \ingroup testing
+ * Enable examples to be run as meaningful tests.
+ * Declaration of classes ns3::ExampleAsTestSuite and ns3::ExampleAsTestCase.
+ */
+
+namespace ns3 {
+
+
+/**
+ * \ingroup testing
+ * Execute an example program as a test, by comparing the output
+ * to a reference file.
+ *
+ * User can subclass and override the GetCommandTemplate and
+ * GetPostProcessingCommand methods if more complex
+ * example invocation patterns are required.
+ *
+ * \see examples-as-tests-test-suite.cc
+ */
+class ExampleAsTestCase : public TestCase
+{
+public:
+  /**
+   * Constructor.
+   * \param [in] name The test case name, typically the program name
+   *                  and summary of the arguments, such as `my-example-foo`
+   * \param [in] program The actual example program names, such as `my-example`
+   * \param [in] dataDir The location of the reference file.
+   *                  This is normally provided by the symbol
+   *                  `NS_TEST_SOURCEDIR` in the `module-examples-test-suite.cc`
+   *                  file.
+   *                  The reference file should be named after
+   *                  the test case name,
+   *                  for example `my-example-foo.log`.  If you use
+   *                  the `--update` argument to `test.py` or
+   *                  `test-runner` the reference file will be created
+   *                  with the correct name.
+   * \param [in] args Any additional arguments to the program.
+   */
+  ExampleAsTestCase (const std::string name,
+                     const std::string program,
+                     const std::string dataDir,
+                     const std::string args = "");
+
+  /** Destructor. */
+  virtual ~ExampleAsTestCase (void);
+
+  /**
+   * Customization point for more complicated patterns
+   * to invoke the example program.
+   *
+   * \returns The string to be given to the `waf --command-template=` argument.
+   */
+  virtual std::string GetCommandTemplate (void) const;
+
+  /**
+   * Customization point for tests requiring post-processing of stdout.
+   *
+   * For example to sort return "| sort"
+   *
+   * Default is "", no processing step.
+   *
+   * \returns The string of post-processing commands
+   */
+  virtual std::string GetPostProcessingCommand (void) const;
+
+  // Inherited
+  virtual void DoRun (void);
+
+protected:
+  std::string m_program;  /**< The program to run. */
+  std::string m_dataDir;  /**< The source directory for the test. */
+  std::string m_args;     /**< Any additional arguments to the program. */
+
+};  // class ExampleAsTestCase
+
+/**
+ * \ingroup testing
+ * Execute an example program as a test suite.
+ *
+ * You can use this TestSuite to add an example to the test suite with
+ * checking of the example output (`std::out` and `std::err`).  This
+ * is an alternative to adding an example using the
+ * `examples-to-run.py` file. The key difference between the two
+ * methods is what criteria is used to for success.  Examples added to
+ * `examples-to-run.py` will be run and the exit status checked
+ * (non-zero indicates failure).  ExampleAsTestSuite adds checking of
+ * output against a specified known "good" reference file.  
+ *
+ * \warning If you are thinking about using this class, strongly
+ * consider using a standard test instead.  The TestSuite class has
+ * better checking using the NS_TEST_* macros and in almost all cases
+ * is the better approach.  If your test can be done with a TestSuite
+ * class you will be asked by the reviewers to rewrite the test when
+ * you do a pull request.
+ *
+ * \par Test Addition
+ *
+ * To use an example program as a test you need to create a test suite
+ * file and add it to the appropriate list in your module wscript
+ * file. The "good" output reference file needs to be generated for
+ * detecting regressions.
+ *
+ * Let's assume your module is called `mymodule`, and the example
+ * program is `mymodule/examples/mod-example.cc`.  First you should
+ * create a test file `mymodule/test/mymodule-examples-test-suite.cc`
+ * which looks like this:
+ * 
+ * \code{.cpp}
+ * #include "ns3/example-as-test.h"
+ * static ns3::ExampleAsTestSuite g_modExampleOne ("mymodule-example-mod-example-one", "mod-example", NS_TEST_SOURCEDIR, "--arg-one");
+ * static ns3::ExampleAsTestSuite g_modExampleTwo ("mymodule-example-mod-example-two", "mod-example", NS_TEST_SOURCEDIR, "--arg-two");
+ * \endcode
+ *
+ * The arguments to the constructor is the name of the test suite, the
+ * example to run, the directory that contains the "good" reference file
+ * (the macro `NS_TEST_SOURCEDIR` is normally the correct directory),
+ * and command line arguments for the example.  In the preceding code
+ * the same example is run twice with different arguments.
+ *
+ * You then need to add that newly created test suite file to the list
+ * of test sources in `mymodule/wscript`.   Building of examples
+ * is an option so you need to guard the inclusion of the test suite:
+ *
+ * \code{.py}
+ * if (bld.env['ENABLE_EXAMPLES']):
+ *    module.source.append('model/mymodule-examples-test-suite.cc')
+ * \endcode
+ *
+ * Since you modified a wscript file you need to reconfigure and
+ * rebuild everything.
+ *
+ * You just added new tests so you will need to generate the "good"
+ * output reference files that will be used to verify the example:
+ *
+ * `./test.py --suite="mymodule-example-*" --update`
+ *
+ * This will run all tests starting with "mymodule-example-" and save
+ * new "good" reference files.  Updating the reference file should be
+ * done when you create the test and whenever output changes.  When
+ * updating the reference output you should inspect it to ensure that
+ * it is valid.  The reference files should be committed with the new
+ * test.
+ *
+ * \par Test Verification
+ *
+ * You can run the test with the standard `test.py` script.  For
+ * example to run the suites you just added:
+ *
+ * `./test.py --suite="mymodule-example-*"`
+ *
+ * This will run all `mymodule-example-...` tests and report whether they
+ * produce output matching the reference files.
+ * 
+ * \par Writing good examples for testing
+ *
+ * When setting up an example for use by this class you should be very
+ * careful about what output the example generates.  For example,
+ * writing output which includes simulation time (especially high
+ * resolution time) makes the test sensitive to potentially minor
+ * changes in event times.  This makes the reference output hard to
+ * verify and hard to keep up-to-date.  Output as little as needed for
+ * the example and include only behavioral state that is important for
+ * determining if the example has run correctly.
+ * 
+ */
+class ExampleAsTestSuite : public TestSuite
+{
+public:
+  /**
+   * \copydoc ExampleAsTestCase::ExampleAsTestCase
+   * \param [in] duration Amount of time this test takes to execute
+   *             (defaults to QUICK).
+   */
+  ExampleAsTestSuite (const std::string name,
+                      const std::string program,
+                      const std::string dataDir,
+                      const std::string args = "",
+                      const TestDuration duration = QUICK);
+};  // class ExampleAsTestSuite
+
+
+} // namespace ns3
+
+#endif  /* NS3_EXAMPLE_TEST_SUITE_H */
